/* Automatically generated nanopb header */
/* Generated by nanopb-0.4.6 at Thu Jun  9 14:18:28 2022. */

#ifndef PB_WIPPERSNAPPER_I2C_V1_WIPPERSNAPPER_I2C_V1_I2C_PB_H_INCLUDED
#define PB_WIPPERSNAPPER_I2C_V1_WIPPERSNAPPER_I2C_V1_I2C_PB_H_INCLUDED
#include <pb.h>
#include "nanopb/nanopb.pb.h"

#if PB_PROTO_HEADER_VERSION != 40
#error Regenerate this file with the current version of nanopb generator.
#endif

/* Enum definitions */
/* *
 BusResponse represents the state of the I2C bus, from a device. */
typedef enum _wippersnapper_i2c_v1_BusResponse { 
    wippersnapper_i2c_v1_BusResponse_BUS_RESPONSE_UNSPECIFIED = 0, /* * Unspecified error occurred. * */
    wippersnapper_i2c_v1_BusResponse_BUS_RESPONSE_SUCCESS = 1, /* * I2C bus successfully initialized. * */
    wippersnapper_i2c_v1_BusResponse_BUS_RESPONSE_ERROR_HANG = 2, /* * I2C Bus hang, user should reset their board if this persists. * */
    wippersnapper_i2c_v1_BusResponse_BUS_RESPONSE_ERROR_PULLUPS = 3, /* * I2C bus failed to initialize - SDA or SCL needs a pull up. * */
    wippersnapper_i2c_v1_BusResponse_BUS_RESPONSE_ERROR_WIRING = 4, /* * I2C bus failed to communicate - Please check your wiring. * */
    wippersnapper_i2c_v1_BusResponse_BUS_RESPONSE_UNSUPPORTED_SENSOR = 5, /* * WipperSnapper firmware is outdated and does not include the sensor type - Please update your WipperSnapper firmware. * */
    wippersnapper_i2c_v1_BusResponse_BUS_RESPONSE_DEVICE_INIT_FAIL = 6, /* * I2C device failed to initialize. * */
    wippersnapper_i2c_v1_BusResponse_BUS_RESPONSE_DEVICE_DEINIT_FAIL = 7 /* * I2C device failed to de-initialize. * */
} wippersnapper_i2c_v1_BusResponse;

/* *
 SensorType allows us determine what types of units the sensor uses, etc. */
typedef enum _wippersnapper_i2c_v1_SensorType { 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_UNSPECIFIED = 0, 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_ACCELEROMETER = 1, /* * Gravity + linear acceleration */
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_MAGNETIC_FIELD = 2, 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_ORIENTATION = 3, 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_GYROSCOPE = 4, 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_LIGHT = 5, 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_PRESSURE = 6, 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_PROXIMITY = 8, 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_GRAVITY = 9, 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_LINEAR_ACCELERATION = 10, /* * Acceleration not including gravity */
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_ROTATION_VECTOR = 11, 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_RELATIVE_HUMIDITY = 12, 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_AMBIENT_TEMPERATURE = 13, 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_OBJECT_TEMPERATURE = 14, 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_VOLTAGE = 15, 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_CURRENT = 16, 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_COLOR = 17, 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_RAW = 18, 
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_PM10_STD = 19, /* * Standard Particulate Matter 1.0 */
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_PM25_STD = 20, /* * Standard Particulate Matter 2.5 */
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_PM100_STD = 21, /* * Standard Particulate Matter 100 */
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_PM10_ENV = 22, /* * Environmental Particulate Matter 1.0 */
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_PM25_ENV = 23, /* * Environmental Particulate Matter 2.5 */
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_PM100_ENV = 24, /* * Environmental Particulate Matter 100 */
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_CO2 = 25, /* * CO2 */
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_GAS_RESISTANCE = 26, /* * The resistance (in Ohms) of the gas sensor.  This is proportional to the amount of VOC particles in the air. */
    wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_ALTITUDE = 27 /* * The altitude in meters. */
} wippersnapper_i2c_v1_SensorType;

/* Struct definitions */
/* *
 Represents a list of I2CDeviceInitRequest messages. */
typedef struct _wippersnapper_i2c_v1_I2CDeviceInitRequests { 
    pb_callback_t list;
} wippersnapper_i2c_v1_I2CDeviceInitRequests;

/* *
 I2CBusInitRequest represents a request to
 initialize the I2C bus from the broker. */
typedef struct _wippersnapper_i2c_v1_I2CBusInitRequest { 
    int32_t i2c_pin_scl; /* * The desired I2C SCL pin. */
    int32_t i2c_pin_sda; /* * The desired I2C SDA pin. */
    uint32_t i2c_frequency; /* * The desired I2C SCL frequency, in Hz. Default is 100000Hz. */
    int32_t i2c_port_number; /* * The I2C port number. */
} wippersnapper_i2c_v1_I2CBusInitRequest;

/* *
 I2CBusInitResponse represents a response to I2CBusInitRequest */
typedef struct _wippersnapper_i2c_v1_I2CBusInitResponse { 
    wippersnapper_i2c_v1_BusResponse bus_response; /* * Whether the I2C bus initialized properly or failed. * */
} wippersnapper_i2c_v1_I2CBusInitResponse;

/* *
 I2CBusScanResponse represents a list of I2C addresses
 found on the bus after I2CBusScanRequest has executed. */
typedef struct _wippersnapper_i2c_v1_I2CBusScanResponse { 
    pb_size_t addresses_found_count;
    uint32_t addresses_found[120]; /* * The 7-bit addresses of the I2C devices found on the bus, empty if not found. */
    wippersnapper_i2c_v1_BusResponse bus_response; /* * The I2C bus' status. * */
} wippersnapper_i2c_v1_I2CBusScanResponse;

/* *
 I2CBusSetFrequency represents a request to change the
 I2C clock speed to a desired frequency, in Hz. */
typedef struct _wippersnapper_i2c_v1_I2CBusSetFrequency { 
    uint32_t frequency; /* * The desired I2C SCL frequency, in Hz. */
    int32_t bus_id; /* * An optional I2C bus identifier, if multiple exist. */
} wippersnapper_i2c_v1_I2CBusSetFrequency;

/* *
 I2CDeviceDeinitRequest is a wrapper message containing
 a deinitialization request for a specific i2c device. */
typedef struct _wippersnapper_i2c_v1_I2CDeviceDeinitRequest { 
    int32_t i2c_port_number; /* * The desired I2C port to de-initialize an I2C device on. */
    uint32_t i2c_device_address; /* * The 7-bit I2C address of the device on the bus. */
} wippersnapper_i2c_v1_I2CDeviceDeinitRequest;

/* *
 I2CDeviceDeinitResponse represents if an I2C device's
 sensor(s) is/are successfully de-initialized. */
typedef struct _wippersnapper_i2c_v1_I2CDeviceDeinitResponse { 
    uint32_t i2c_device_address; /* * The 7-bit I2C address of the device which was initialized. */
    wippersnapper_i2c_v1_BusResponse bus_response; /* * The I2C bus' status. * */
} wippersnapper_i2c_v1_I2CDeviceDeinitResponse;

/* *
 I2CDeviceInitResponse contains the response from a
 device after processing a I2CDeviceInitRequest message. */
typedef struct _wippersnapper_i2c_v1_I2CDeviceInitResponse { 
    uint32_t i2c_device_address; /* * The 7-bit I2C address of the device on the bus. */
    wippersnapper_i2c_v1_BusResponse bus_response; /* * The I2C bus' status. * */
} wippersnapper_i2c_v1_I2CDeviceInitResponse;

/* *
 I2CDeviceSensorProperties contains
 the properties of an I2C device's sensor such as
 its type and period. */
typedef struct _wippersnapper_i2c_v1_I2CDeviceSensorProperties { 
    wippersnapper_i2c_v1_SensorType sensor_type;
    uint32_t sensor_period;
} wippersnapper_i2c_v1_I2CDeviceSensorProperties;

/* *
 I2CDeviceUpdateResponse represents if an I2C device's
 sensor(s) is/are successfully updated. */
typedef struct _wippersnapper_i2c_v1_I2CDeviceUpdateResponse { 
    uint32_t i2c_device_address; /* * The 7-bit I2C address of the device which was updated. */
    wippersnapper_i2c_v1_BusResponse bus_response; /* * The I2C bus' status. * */
} wippersnapper_i2c_v1_I2CDeviceUpdateResponse;

/* *
 SensorEvent  is used to return the sensor's value and type. */
typedef struct _wippersnapper_i2c_v1_SensorEvent { 
    wippersnapper_i2c_v1_SensorType type; /* * The sensor's type and corresponding SI unit */
    float value; /* * The sensor's value */
} wippersnapper_i2c_v1_SensorEvent;

/* *
 I2CBusScanRequest represents the parameters required to execute
 a device's I2C scan. */
typedef struct _wippersnapper_i2c_v1_I2CBusScanRequest { 
    int32_t i2c_port_number; /* * The desired I2C port to scan. */
    bool has_bus_init_request;
    wippersnapper_i2c_v1_I2CBusInitRequest bus_init_request; /* * The I2C bus initialization request. */
} wippersnapper_i2c_v1_I2CBusScanRequest;

/* *
 Each I2CDeviceEvent represents data from **one** I2C sensor.
 NOTE: An I2CDeviceEvent can have multiple sensor events if
 the I2C device contains > 1 sensor. */
typedef struct _wippersnapper_i2c_v1_I2CDeviceEvent { 
    uint32_t sensor_address; /* * The 7-bit I2C address of the I2C device. */
    pb_size_t sensor_event_count;
    wippersnapper_i2c_v1_SensorEvent sensor_event[15]; /* * A, optionally repeated, SensorEvent from a sensor. */
} wippersnapper_i2c_v1_I2CDeviceEvent;

/* *
 I2CDeviceInitRequest is a wrapper message for
 an I2C device initialization request. */
typedef struct _wippersnapper_i2c_v1_I2CDeviceInitRequest { 
    int32_t i2c_port_number; /* * The desired I2C port to initialize an I2C device on. */
    bool has_i2c_bus_init_req;
    wippersnapper_i2c_v1_I2CBusInitRequest i2c_bus_init_req; /* * An I2C bus initialization request. */
    uint32_t i2c_device_address; /* * The 7-bit I2C address of the device on the bus. */
    char i2c_device_name[15]; /* * The I2C device's name, MUST MATCH the name on the JSON definition file on https://github.com/adafruit/Wippersnapper_Components. */
    pb_size_t i2c_device_properties_count;
    wippersnapper_i2c_v1_I2CDeviceSensorProperties i2c_device_properties[15]; /* * Properties of each sensor on the I2C device. */
} wippersnapper_i2c_v1_I2CDeviceInitRequest;

/* *
 I2CDeviceUpdateRequest is a wrapper message which
 contains a message to update a specific device's properties. */
typedef struct _wippersnapper_i2c_v1_I2CDeviceUpdateRequest { 
    int32_t i2c_port_number; /* * The desired I2C port. */
    uint32_t i2c_device_address; /* * The 7-bit I2C address of the device on the bus. */
    char i2c_device_name[15]; /* * The I2C device's name, MUST MATCH the name on the JSON file. */
    pb_size_t i2c_device_properties_count;
    wippersnapper_i2c_v1_I2CDeviceSensorProperties i2c_device_properties[15]; /* * Properties for the I2C device's sensors. */
} wippersnapper_i2c_v1_I2CDeviceUpdateRequest;


/* Helper constants for enums */
#define _wippersnapper_i2c_v1_BusResponse_MIN wippersnapper_i2c_v1_BusResponse_BUS_RESPONSE_UNSPECIFIED
#define _wippersnapper_i2c_v1_BusResponse_MAX wippersnapper_i2c_v1_BusResponse_BUS_RESPONSE_DEVICE_DEINIT_FAIL
#define _wippersnapper_i2c_v1_BusResponse_ARRAYSIZE ((wippersnapper_i2c_v1_BusResponse)(wippersnapper_i2c_v1_BusResponse_BUS_RESPONSE_DEVICE_DEINIT_FAIL+1))

#define _wippersnapper_i2c_v1_SensorType_MIN wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_UNSPECIFIED
#define _wippersnapper_i2c_v1_SensorType_MAX wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_ALTITUDE
#define _wippersnapper_i2c_v1_SensorType_ARRAYSIZE ((wippersnapper_i2c_v1_SensorType)(wippersnapper_i2c_v1_SensorType_SENSOR_TYPE_ALTITUDE+1))


#ifdef __cplusplus
extern "C" {
#endif

/* Initializer values for message structs */
#define wippersnapper_i2c_v1_I2CBusInitRequest_init_default {0, 0, 0, 0}
#define wippersnapper_i2c_v1_I2CBusInitResponse_init_default {_wippersnapper_i2c_v1_BusResponse_MIN}
#define wippersnapper_i2c_v1_I2CBusSetFrequency_init_default {0, 0}
#define wippersnapper_i2c_v1_I2CBusScanRequest_init_default {0, false, wippersnapper_i2c_v1_I2CBusInitRequest_init_default}
#define wippersnapper_i2c_v1_I2CBusScanResponse_init_default {0, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, _wippersnapper_i2c_v1_BusResponse_MIN}
#define wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default {_wippersnapper_i2c_v1_SensorType_MIN, 0}
#define wippersnapper_i2c_v1_I2CDeviceInitRequests_init_default {{{NULL}, NULL}}
#define wippersnapper_i2c_v1_I2CDeviceInitRequest_init_default {0, false, wippersnapper_i2c_v1_I2CBusInitRequest_init_default, 0, "", 0, {wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default}}
#define wippersnapper_i2c_v1_I2CDeviceInitResponse_init_default {0, _wippersnapper_i2c_v1_BusResponse_MIN}
#define wippersnapper_i2c_v1_I2CDeviceUpdateRequest_init_default {0, 0, "", 0, {wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_default}}
#define wippersnapper_i2c_v1_I2CDeviceUpdateResponse_init_default {0, _wippersnapper_i2c_v1_BusResponse_MIN}
#define wippersnapper_i2c_v1_I2CDeviceDeinitRequest_init_default {0, 0}
#define wippersnapper_i2c_v1_I2CDeviceDeinitResponse_init_default {0, _wippersnapper_i2c_v1_BusResponse_MIN}
#define wippersnapper_i2c_v1_SensorEvent_init_default {_wippersnapper_i2c_v1_SensorType_MIN, 0}
#define wippersnapper_i2c_v1_I2CDeviceEvent_init_default {0, 0, {wippersnapper_i2c_v1_SensorEvent_init_default, wippersnapper_i2c_v1_SensorEvent_init_default, wippersnapper_i2c_v1_SensorEvent_init_default, wippersnapper_i2c_v1_SensorEvent_init_default, wippersnapper_i2c_v1_SensorEvent_init_default, wippersnapper_i2c_v1_SensorEvent_init_default, wippersnapper_i2c_v1_SensorEvent_init_default, wippersnapper_i2c_v1_SensorEvent_init_default, wippersnapper_i2c_v1_SensorEvent_init_default, wippersnapper_i2c_v1_SensorEvent_init_default, wippersnapper_i2c_v1_SensorEvent_init_default, wippersnapper_i2c_v1_SensorEvent_init_default, wippersnapper_i2c_v1_SensorEvent_init_default, wippersnapper_i2c_v1_SensorEvent_init_default, wippersnapper_i2c_v1_SensorEvent_init_default}}
#define wippersnapper_i2c_v1_I2CBusInitRequest_init_zero {0, 0, 0, 0}
#define wippersnapper_i2c_v1_I2CBusInitResponse_init_zero {_wippersnapper_i2c_v1_BusResponse_MIN}
#define wippersnapper_i2c_v1_I2CBusSetFrequency_init_zero {0, 0}
#define wippersnapper_i2c_v1_I2CBusScanRequest_init_zero {0, false, wippersnapper_i2c_v1_I2CBusInitRequest_init_zero}
#define wippersnapper_i2c_v1_I2CBusScanResponse_init_zero {0, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, _wippersnapper_i2c_v1_BusResponse_MIN}
#define wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero {_wippersnapper_i2c_v1_SensorType_MIN, 0}
#define wippersnapper_i2c_v1_I2CDeviceInitRequests_init_zero {{{NULL}, NULL}}
#define wippersnapper_i2c_v1_I2CDeviceInitRequest_init_zero {0, false, wippersnapper_i2c_v1_I2CBusInitRequest_init_zero, 0, "", 0, {wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero}}
#define wippersnapper_i2c_v1_I2CDeviceInitResponse_init_zero {0, _wippersnapper_i2c_v1_BusResponse_MIN}
#define wippersnapper_i2c_v1_I2CDeviceUpdateRequest_init_zero {0, 0, "", 0, {wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero, wippersnapper_i2c_v1_I2CDeviceSensorProperties_init_zero}}
#define wippersnapper_i2c_v1_I2CDeviceUpdateResponse_init_zero {0, _wippersnapper_i2c_v1_BusResponse_MIN}
#define wippersnapper_i2c_v1_I2CDeviceDeinitRequest_init_zero {0, 0}
#define wippersnapper_i2c_v1_I2CDeviceDeinitResponse_init_zero {0, _wippersnapper_i2c_v1_BusResponse_MIN}
#define wippersnapper_i2c_v1_SensorEvent_init_zero {_wippersnapper_i2c_v1_SensorType_MIN, 0}
#define wippersnapper_i2c_v1_I2CDeviceEvent_init_zero {0, 0, {wippersnapper_i2c_v1_SensorEvent_init_zero, wippersnapper_i2c_v1_SensorEvent_init_zero, wippersnapper_i2c_v1_SensorEvent_init_zero, wippersnapper_i2c_v1_SensorEvent_init_zero, wippersnapper_i2c_v1_SensorEvent_init_zero, wippersnapper_i2c_v1_SensorEvent_init_zero, wippersnapper_i2c_v1_SensorEvent_init_zero, wippersnapper_i2c_v1_SensorEvent_init_zero, wippersnapper_i2c_v1_SensorEvent_init_zero, wippersnapper_i2c_v1_SensorEvent_init_zero, wippersnapper_i2c_v1_SensorEvent_init_zero, wippersnapper_i2c_v1_SensorEvent_init_zero, wippersnapper_i2c_v1_SensorEvent_init_zero, wippersnapper_i2c_v1_SensorEvent_init_zero, wippersnapper_i2c_v1_SensorEvent_init_zero}}

/* Field tags (for use in manual encoding/decoding) */
#define wippersnapper_i2c_v1_I2CDeviceInitRequests_list_tag 1
#define wippersnapper_i2c_v1_I2CBusInitRequest_i2c_pin_scl_tag 1
#define wippersnapper_i2c_v1_I2CBusInitRequest_i2c_pin_sda_tag 2
#define wippersnapper_i2c_v1_I2CBusInitRequest_i2c_frequency_tag 3
#define wippersnapper_i2c_v1_I2CBusInitRequest_i2c_port_number_tag 4
#define wippersnapper_i2c_v1_I2CBusInitResponse_bus_response_tag 2
#define wippersnapper_i2c_v1_I2CBusScanResponse_addresses_found_tag 1
#define wippersnapper_i2c_v1_I2CBusScanResponse_bus_response_tag 2
#define wippersnapper_i2c_v1_I2CBusSetFrequency_frequency_tag 1
#define wippersnapper_i2c_v1_I2CBusSetFrequency_bus_id_tag 2
#define wippersnapper_i2c_v1_I2CDeviceDeinitRequest_i2c_port_number_tag 1
#define wippersnapper_i2c_v1_I2CDeviceDeinitRequest_i2c_device_address_tag 2
#define wippersnapper_i2c_v1_I2CDeviceDeinitResponse_i2c_device_address_tag 2
#define wippersnapper_i2c_v1_I2CDeviceDeinitResponse_bus_response_tag 3
#define wippersnapper_i2c_v1_I2CDeviceInitResponse_i2c_device_address_tag 2
#define wippersnapper_i2c_v1_I2CDeviceInitResponse_bus_response_tag 3
#define wippersnapper_i2c_v1_I2CDeviceSensorProperties_sensor_type_tag 1
#define wippersnapper_i2c_v1_I2CDeviceSensorProperties_sensor_period_tag 2
#define wippersnapper_i2c_v1_I2CDeviceUpdateResponse_i2c_device_address_tag 1
#define wippersnapper_i2c_v1_I2CDeviceUpdateResponse_bus_response_tag 3
#define wippersnapper_i2c_v1_SensorEvent_type_tag 1
#define wippersnapper_i2c_v1_SensorEvent_value_tag 2
#define wippersnapper_i2c_v1_I2CBusScanRequest_i2c_port_number_tag 1
#define wippersnapper_i2c_v1_I2CBusScanRequest_bus_init_request_tag 2
#define wippersnapper_i2c_v1_I2CDeviceEvent_sensor_address_tag 1
#define wippersnapper_i2c_v1_I2CDeviceEvent_sensor_event_tag 2
#define wippersnapper_i2c_v1_I2CDeviceInitRequest_i2c_port_number_tag 1
#define wippersnapper_i2c_v1_I2CDeviceInitRequest_i2c_bus_init_req_tag 2
#define wippersnapper_i2c_v1_I2CDeviceInitRequest_i2c_device_address_tag 3
#define wippersnapper_i2c_v1_I2CDeviceInitRequest_i2c_device_name_tag 4
#define wippersnapper_i2c_v1_I2CDeviceInitRequest_i2c_device_properties_tag 5
#define wippersnapper_i2c_v1_I2CDeviceUpdateRequest_i2c_port_number_tag 1
#define wippersnapper_i2c_v1_I2CDeviceUpdateRequest_i2c_device_address_tag 2
#define wippersnapper_i2c_v1_I2CDeviceUpdateRequest_i2c_device_name_tag 3
#define wippersnapper_i2c_v1_I2CDeviceUpdateRequest_i2c_device_properties_tag 4

/* Struct field encoding specification for nanopb */
#define wippersnapper_i2c_v1_I2CBusInitRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, INT32,    i2c_pin_scl,       1) \
X(a, STATIC,   SINGULAR, INT32,    i2c_pin_sda,       2) \
X(a, STATIC,   SINGULAR, UINT32,   i2c_frequency,     3) \
X(a, STATIC,   SINGULAR, INT32,    i2c_port_number,   4)
#define wippersnapper_i2c_v1_I2CBusInitRequest_CALLBACK NULL
#define wippersnapper_i2c_v1_I2CBusInitRequest_DEFAULT NULL

#define wippersnapper_i2c_v1_I2CBusInitResponse_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    bus_response,      2)
#define wippersnapper_i2c_v1_I2CBusInitResponse_CALLBACK NULL
#define wippersnapper_i2c_v1_I2CBusInitResponse_DEFAULT NULL

#define wippersnapper_i2c_v1_I2CBusSetFrequency_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   frequency,         1) \
X(a, STATIC,   SINGULAR, INT32,    bus_id,            2)
#define wippersnapper_i2c_v1_I2CBusSetFrequency_CALLBACK NULL
#define wippersnapper_i2c_v1_I2CBusSetFrequency_DEFAULT NULL

#define wippersnapper_i2c_v1_I2CBusScanRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, INT32,    i2c_port_number,   1) \
X(a, STATIC,   OPTIONAL, MESSAGE,  bus_init_request,   2)
#define wippersnapper_i2c_v1_I2CBusScanRequest_CALLBACK NULL
#define wippersnapper_i2c_v1_I2CBusScanRequest_DEFAULT NULL
#define wippersnapper_i2c_v1_I2CBusScanRequest_bus_init_request_MSGTYPE wippersnapper_i2c_v1_I2CBusInitRequest

#define wippersnapper_i2c_v1_I2CBusScanResponse_FIELDLIST(X, a) \
X(a, STATIC,   REPEATED, UINT32,   addresses_found,   1) \
X(a, STATIC,   SINGULAR, UENUM,    bus_response,      2)
#define wippersnapper_i2c_v1_I2CBusScanResponse_CALLBACK NULL
#define wippersnapper_i2c_v1_I2CBusScanResponse_DEFAULT NULL

#define wippersnapper_i2c_v1_I2CDeviceSensorProperties_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    sensor_type,       1) \
X(a, STATIC,   SINGULAR, UINT32,   sensor_period,     2)
#define wippersnapper_i2c_v1_I2CDeviceSensorProperties_CALLBACK NULL
#define wippersnapper_i2c_v1_I2CDeviceSensorProperties_DEFAULT NULL

#define wippersnapper_i2c_v1_I2CDeviceInitRequests_FIELDLIST(X, a) \
X(a, CALLBACK, REPEATED, MESSAGE,  list,              1)
#define wippersnapper_i2c_v1_I2CDeviceInitRequests_CALLBACK pb_default_field_callback
#define wippersnapper_i2c_v1_I2CDeviceInitRequests_DEFAULT NULL
#define wippersnapper_i2c_v1_I2CDeviceInitRequests_list_MSGTYPE wippersnapper_i2c_v1_I2CDeviceInitRequest

#define wippersnapper_i2c_v1_I2CDeviceInitRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, INT32,    i2c_port_number,   1) \
X(a, STATIC,   OPTIONAL, MESSAGE,  i2c_bus_init_req,   2) \
X(a, STATIC,   SINGULAR, UINT32,   i2c_device_address,   3) \
X(a, STATIC,   SINGULAR, STRING,   i2c_device_name,   4) \
X(a, STATIC,   REPEATED, MESSAGE,  i2c_device_properties,   5)
#define wippersnapper_i2c_v1_I2CDeviceInitRequest_CALLBACK NULL
#define wippersnapper_i2c_v1_I2CDeviceInitRequest_DEFAULT NULL
#define wippersnapper_i2c_v1_I2CDeviceInitRequest_i2c_bus_init_req_MSGTYPE wippersnapper_i2c_v1_I2CBusInitRequest
#define wippersnapper_i2c_v1_I2CDeviceInitRequest_i2c_device_properties_MSGTYPE wippersnapper_i2c_v1_I2CDeviceSensorProperties

#define wippersnapper_i2c_v1_I2CDeviceInitResponse_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   i2c_device_address,   2) \
X(a, STATIC,   SINGULAR, UENUM,    bus_response,      3)
#define wippersnapper_i2c_v1_I2CDeviceInitResponse_CALLBACK NULL
#define wippersnapper_i2c_v1_I2CDeviceInitResponse_DEFAULT NULL

#define wippersnapper_i2c_v1_I2CDeviceUpdateRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, INT32,    i2c_port_number,   1) \
X(a, STATIC,   SINGULAR, UINT32,   i2c_device_address,   2) \
X(a, STATIC,   SINGULAR, STRING,   i2c_device_name,   3) \
X(a, STATIC,   REPEATED, MESSAGE,  i2c_device_properties,   4)
#define wippersnapper_i2c_v1_I2CDeviceUpdateRequest_CALLBACK NULL
#define wippersnapper_i2c_v1_I2CDeviceUpdateRequest_DEFAULT NULL
#define wippersnapper_i2c_v1_I2CDeviceUpdateRequest_i2c_device_properties_MSGTYPE wippersnapper_i2c_v1_I2CDeviceSensorProperties

#define wippersnapper_i2c_v1_I2CDeviceUpdateResponse_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   i2c_device_address,   1) \
X(a, STATIC,   SINGULAR, UENUM,    bus_response,      3)
#define wippersnapper_i2c_v1_I2CDeviceUpdateResponse_CALLBACK NULL
#define wippersnapper_i2c_v1_I2CDeviceUpdateResponse_DEFAULT NULL

#define wippersnapper_i2c_v1_I2CDeviceDeinitRequest_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, INT32,    i2c_port_number,   1) \
X(a, STATIC,   SINGULAR, UINT32,   i2c_device_address,   2)
#define wippersnapper_i2c_v1_I2CDeviceDeinitRequest_CALLBACK NULL
#define wippersnapper_i2c_v1_I2CDeviceDeinitRequest_DEFAULT NULL

#define wippersnapper_i2c_v1_I2CDeviceDeinitResponse_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   i2c_device_address,   2) \
X(a, STATIC,   SINGULAR, UENUM,    bus_response,      3)
#define wippersnapper_i2c_v1_I2CDeviceDeinitResponse_CALLBACK NULL
#define wippersnapper_i2c_v1_I2CDeviceDeinitResponse_DEFAULT NULL

#define wippersnapper_i2c_v1_SensorEvent_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UENUM,    type,              1) \
X(a, STATIC,   SINGULAR, FLOAT,    value,             2)
#define wippersnapper_i2c_v1_SensorEvent_CALLBACK NULL
#define wippersnapper_i2c_v1_SensorEvent_DEFAULT NULL

#define wippersnapper_i2c_v1_I2CDeviceEvent_FIELDLIST(X, a) \
X(a, STATIC,   SINGULAR, UINT32,   sensor_address,    1) \
X(a, STATIC,   REPEATED, MESSAGE,  sensor_event,      2)
#define wippersnapper_i2c_v1_I2CDeviceEvent_CALLBACK NULL
#define wippersnapper_i2c_v1_I2CDeviceEvent_DEFAULT NULL
#define wippersnapper_i2c_v1_I2CDeviceEvent_sensor_event_MSGTYPE wippersnapper_i2c_v1_SensorEvent

extern const pb_msgdesc_t wippersnapper_i2c_v1_I2CBusInitRequest_msg;
extern const pb_msgdesc_t wippersnapper_i2c_v1_I2CBusInitResponse_msg;
extern const pb_msgdesc_t wippersnapper_i2c_v1_I2CBusSetFrequency_msg;
extern const pb_msgdesc_t wippersnapper_i2c_v1_I2CBusScanRequest_msg;
extern const pb_msgdesc_t wippersnapper_i2c_v1_I2CBusScanResponse_msg;
extern const pb_msgdesc_t wippersnapper_i2c_v1_I2CDeviceSensorProperties_msg;
extern const pb_msgdesc_t wippersnapper_i2c_v1_I2CDeviceInitRequests_msg;
extern const pb_msgdesc_t wippersnapper_i2c_v1_I2CDeviceInitRequest_msg;
extern const pb_msgdesc_t wippersnapper_i2c_v1_I2CDeviceInitResponse_msg;
extern const pb_msgdesc_t wippersnapper_i2c_v1_I2CDeviceUpdateRequest_msg;
extern const pb_msgdesc_t wippersnapper_i2c_v1_I2CDeviceUpdateResponse_msg;
extern const pb_msgdesc_t wippersnapper_i2c_v1_I2CDeviceDeinitRequest_msg;
extern const pb_msgdesc_t wippersnapper_i2c_v1_I2CDeviceDeinitResponse_msg;
extern const pb_msgdesc_t wippersnapper_i2c_v1_SensorEvent_msg;
extern const pb_msgdesc_t wippersnapper_i2c_v1_I2CDeviceEvent_msg;

/* Defines for backwards compatibility with code written before nanopb-0.4.0 */
#define wippersnapper_i2c_v1_I2CBusInitRequest_fields &wippersnapper_i2c_v1_I2CBusInitRequest_msg
#define wippersnapper_i2c_v1_I2CBusInitResponse_fields &wippersnapper_i2c_v1_I2CBusInitResponse_msg
#define wippersnapper_i2c_v1_I2CBusSetFrequency_fields &wippersnapper_i2c_v1_I2CBusSetFrequency_msg
#define wippersnapper_i2c_v1_I2CBusScanRequest_fields &wippersnapper_i2c_v1_I2CBusScanRequest_msg
#define wippersnapper_i2c_v1_I2CBusScanResponse_fields &wippersnapper_i2c_v1_I2CBusScanResponse_msg
#define wippersnapper_i2c_v1_I2CDeviceSensorProperties_fields &wippersnapper_i2c_v1_I2CDeviceSensorProperties_msg
#define wippersnapper_i2c_v1_I2CDeviceInitRequests_fields &wippersnapper_i2c_v1_I2CDeviceInitRequests_msg
#define wippersnapper_i2c_v1_I2CDeviceInitRequest_fields &wippersnapper_i2c_v1_I2CDeviceInitRequest_msg
#define wippersnapper_i2c_v1_I2CDeviceInitResponse_fields &wippersnapper_i2c_v1_I2CDeviceInitResponse_msg
#define wippersnapper_i2c_v1_I2CDeviceUpdateRequest_fields &wippersnapper_i2c_v1_I2CDeviceUpdateRequest_msg
#define wippersnapper_i2c_v1_I2CDeviceUpdateResponse_fields &wippersnapper_i2c_v1_I2CDeviceUpdateResponse_msg
#define wippersnapper_i2c_v1_I2CDeviceDeinitRequest_fields &wippersnapper_i2c_v1_I2CDeviceDeinitRequest_msg
#define wippersnapper_i2c_v1_I2CDeviceDeinitResponse_fields &wippersnapper_i2c_v1_I2CDeviceDeinitResponse_msg
#define wippersnapper_i2c_v1_SensorEvent_fields &wippersnapper_i2c_v1_SensorEvent_msg
#define wippersnapper_i2c_v1_I2CDeviceEvent_fields &wippersnapper_i2c_v1_I2CDeviceEvent_msg

/* Maximum encoded size of messages (where known) */
/* wippersnapper_i2c_v1_I2CDeviceInitRequests_size depends on runtime parameters */
#define wippersnapper_i2c_v1_I2CBusInitRequest_size 39
#define wippersnapper_i2c_v1_I2CBusInitResponse_size 2
#define wippersnapper_i2c_v1_I2CBusScanRequest_size 52
#define wippersnapper_i2c_v1_I2CBusScanResponse_size 722
#define wippersnapper_i2c_v1_I2CBusSetFrequency_size 17
#define wippersnapper_i2c_v1_I2CDeviceDeinitRequest_size 17
#define wippersnapper_i2c_v1_I2CDeviceDeinitResponse_size 8
#define wippersnapper_i2c_v1_I2CDeviceEvent_size 141
#define wippersnapper_i2c_v1_I2CDeviceInitRequest_size 224
#define wippersnapper_i2c_v1_I2CDeviceInitResponse_size 8
#define wippersnapper_i2c_v1_I2CDeviceSensorProperties_size 8
#define wippersnapper_i2c_v1_I2CDeviceUpdateRequest_size 183
#define wippersnapper_i2c_v1_I2CDeviceUpdateResponse_size 8
#define wippersnapper_i2c_v1_SensorEvent_size    7

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
